TagLibrary (Grails 3.0.10.BUILD-SNAPSHOT)
Date: 2015-12-03

Package: grails.artefact

## [Groovy] Trait TagLibrary

- grails.artefact.TagLibrary

- All Implemented Interfaces and Traits:
    ServletAttributes, TagLibraryInvoker, WebAttributes

      @groovy.transform.CompileStatic
      trait TagLibrary

  A trait that makes a class into a GSP tag library

  Authors:
    Jeff Brown
    Graeme Rocher
  Since:
    3.0

- - ### Methods Summary

    Methods
    Type | Name and description
    --- | ---
    `GrailsPrintWriter` | `getOut()` Obtains the currently output writer
    `TemplateVariableBinding` | `getPageScope()` Obtains the page scope instance
    `java.lang.String` | `getTaglibNamespace()`
    `void` | `initializeTagLibrary()`
    `java.lang.Object` | `propertyMissing(java.lang.String name)` Property missing implementation that looks up tag library namespaces or tags in the default namespace
    `java.lang.Object` | `raw(java.lang.Object value)`
    `void` | `setOut(java.io.Writer newOut)` Sets the current output writer
    `void` | `throwTagError(java.lang.String message)` Throws a GrailsTagException

- - ### Method Detail

    - #### GrailsPrintWriter getOut()

      Obtains the currently output writer

      Returns:
        The writer to use

    - #### TemplateVariableBinding getPageScope()

      Obtains the page scope instance

      Returns:
        The page scope instance

    - #### java.lang.String getTaglibNamespace()

    - #### @javax.annotation.PostConstruct void initializeTagLibrary()

    - #### java.lang.Object propertyMissing(java.lang.String name)

      Property missing implementation that looks up tag library namespaces or tags in the default namespace

      throws:
        MissingPropertyException When no tag namespace or tag is found
      Parameters:
        `name` - The property name
      Returns:
        A tag namespace or a tag in the default namespace

    - #### @groovy.transform.CompileDynamic java.lang.Object raw(java.lang.Object value)

    - #### void setOut(java.io.Writer newOut)

      Sets the current output writer

      Parameters:
        `newOut` - The new output writer

    - #### void throwTagError(java.lang.String message)

      Throws a GrailsTagException

      Parameters:
        `message` - The error message